// ----------------------------------------------------------------------------
//
// ftMain.PAS/DFM                                        Ulrich Mller 07.09.02
//                                                       PCS1700        Delphi4
// ftTeach : HauptForm
//
// DateiName = '' : [NEU]
// RobTyp = rtGreifer : mit Greifer (sonst rtZusatz)
// procedure Zusatz nutzt fr den Greifer (intern) DriveGrip neben MoveTo fr
// die Fahrmotoren. HomeRun ffnet Greifer ber MoveHome.
// Beide Flle erfordern einen MotCnl-Eintrag
// Die Positionsanzeige erfolgt permanent ber tmrI (nicht wie ebenfalls
// mglich ber OnFishPosition (weil Timer eh schon den Status des
// Interfaces berwacht).
//
// Das TeachIn-Panel wird durch Shapes und Labels gebildet :
// shpSaule mit shpM1R, shpM1L und lblM1Pos mit Tag = 2 und 1 fr shpM1
// die anderen Elemente entsprechend
//
// Durchgngig Abfrage RobModell <> 'Rob5' zur Behandlung des Sonderfalls
// Rob5 mit Extension Module. Der Greifer liegt dann auf MotCntl 5 um den
// Wagen bndig auf MotCntl 4 plazieren zu knnen.
// TODO : ftModell-Anpassungen
//
// ----------------------------------------------------------------------------

unit ftMain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Menus, ExtCtrls, IniFiles, FishFa50;

type
  TPrgModus = (mdNone, mdEin, mdHome, mdTeachIn, mdRun);
  TfrmMain = class(TForm)
    cmdAction: TButton;
    cmdEnde: TButton;
    cmdInterface: TButton;
    lblPrgModus: TLabel;
    pnlFahren: TPanel;
    memDaten: TMemo;
    lblTitel: TLabel;
    MainMenu1: TMainMenu;
    mnuDatei: TMenuItem;
    pnlPosition: TPanel;
    pnlRun: TPanel;
    cmdScriptStarten: TButton;
    chkWiederholen: TCheckBox;
    cmdZuruck: TButton;
    cmdVor: TButton;
    cmdAufPosition: TButton;
    cmdPosSpeichern: TButton;
    cmdPosEinfugen: TButton;
    cmdPosAnfugen: TButton;
    cmdPosLoschen: TButton;
    mnuOPtionen: TMenuItem;
    mnuHilfe: TMenuItem;
    shpInterface: TShape;
    tmrI: TTimer;
    shpSaule: TShape;
    shpArmV: TShape;
    shpArmH: TShape;
    shpZusatz: TShape;
    lblM4Zu: TLabel;
    lblM4Auf: TLabel;
    sphM2R: TShape;
    shpM2L: TShape;
    shpM3L: TShape;
    shpM3R: TShape;
    shpM1L: TShape;
    shpM1R: TShape;
    lblM2Pos: TLabel;
    lblM3Pos: TLabel;
    lblM1Pos: TLabel;
    mnuNeu: TMenuItem;
    mnuOffnen: TMenuItem;
    mnuSpeichern: TMenuItem;
    mnuSpeichernU: TMenuItem;
    N1: TMenuItem;
    mnuEnde: TMenuItem;
    dlgOpen: TOpenDialog;
    dlgSave: TSaveDialog;
    lstScript: TListBox;
    mnuSchnitt: TMenuItem;
    mnuModell: TMenuItem;
    mnuInhalt: TMenuItem;
    N2: TMenuItem;
    mnuAbout: TMenuItem;
    Shape5: TShape;
    shpM6: TShape;
    shpM7: TShape;
    lblM7Zu: TLabel;
    lblM7Auf: TLabel;
    shpM8: TShape;
    lblM8Zu: TLabel;
    lblM8Auf: TLabel;
    shpWagen: TShape;
    shpM5L: TShape;
    lblM5Pos: TLabel;
    shpM5R: TShape;
    lblM6Zu: TLabel;
    lblM6Auf: TLabel;
    procedure cmdActionClick(Sender: TObject);
    procedure cmdEndeClick(Sender: TObject);
    procedure cmdScriptStartenClick(Sender: TObject);
    procedure cmdPosAnfugenClick(Sender: TObject);
    procedure cmdPosSpeichernClick(Sender: TObject);
    procedure cmdPosEinfugenClick(Sender: TObject);
    procedure cmdPosLoschenClick(Sender: TObject);
    procedure cmdZuPositionClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure lblM4Click(Sender: TObject);
    procedure mnuEndeClick(Sender: TObject);
    procedure mnuOffnenClick(Sender: TObject);
    procedure mnuNeuClick(Sender: TObject);
    procedure mnuSpeichernUClick(Sender: TObject);
    procedure mnuSpeichernClick(Sender: TObject);
    procedure shpMotMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure shpMotMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure tmrITimer(Sender: TObject);
    procedure mnuModellClick(Sender: TObject);
    procedure mnuAboutClick(Sender: TObject);
    procedure mnuSchnittClick(Sender: TObject);
    procedure mnuInhaltClick(Sender: TObject);
    procedure cmdInterfaceClick(Sender: TObject);
    procedure lblM6Click(Sender: TObject);
    procedure lblM7Click(Sender: TObject);
    procedure lblM8Click(Sender: TObject);
  private
    procedure Beenden;
    procedure HomeRun;
    procedure IniLesen;
    procedure IniSchreiben;
    procedure ModellDaten;
    procedure ModusWechsel(NewMode: TPrgModus);
    procedure MotorListe;
    function  MotToScript:string ;
    procedure ScriptToMove;
    procedure Zusatz(OnOff: Cardinal);
    procedure ZusatzM(ZusatzNr, OnOff: Cardinal);
  public
    { Public-Deklarationen }
  end;

const
  clHellGrau = $E0E0E0; rtGreifer = 'G'; rtZusatz = 'Z';
var
  frmMain: TfrmMain;
  ft: TFishRobot;
  PrgModus: TPrgModus; INI: TIniFile; Pfad, DateiName: string;
  PortName: string; LPTDelay: LongWord;
  RobTyp, RobModell, RobExt, RobBez: string;


implementation

uses ftModell, ftAbout, ftSchnit;

{$R *.DFM}

var
  MoveWerte: array[1..8] of Integer; IsDirty: Boolean;


procedure TfrmMain.Beenden;
// --- Beenden des gesamten Programmes ----------------------
begin
  tmrI.Enabled := false;
  IniSchreiben;
  if IsDirty then if MessageDlg('Script-Datei Speichern?',
                       mtInformation, [mbYes, mbNo], 0) = mrYes then
                          mnuSpeichernUClick(Self);
  Sleep(ft.StopControlTime);
  ft.CloseInterface;
  ft.Free;
  INI.Free;
end;


procedure TfrmMain.HomeRun;
// -------------------- Anfahren der Home-Position -----------------------
var i: cardinal;
begin
  ft.NotHalt := false;
  ft.MoveHome;
  ft.ClearMotors;
  for i := 1 to 8 do MoveWerte[i] := 0;
end;


procedure TfrmMain.IniLesen;
// --- Einlesen der ftTeach.INI-Daten ----------------------
begin
  Self.Left := INI.ReadInteger('Common', 'Left', 50);
  Self.Top  := INI.ReadInteger('Common', 'Top',  50);
  RobModell := INI.ReadString('Common', 'RobModel', 'Rob3');
  PortName  := INI.ReadString('Port', 'PortName', 'COM1');
  LPTDelay  := INI.ReadInteger('Port', 'LPTDelay', 10);
  RobTyp    := INI.ReadString(RobModell, 'RobType', rtGreifer);
  RobBez    := INI.ReadString(RobModell, 'RobText', 'Sulenroboter');
  RobExt    := 'RB' + RobModell[Length(RobModell)];
  ft.MotCntl.EndPosition[1] := INI.ReadInteger(RobModell, 'Sule', 240);
  ft.MotCntl.EndPosition[2] := INI.ReadInteger(RobModell, 'ArmH', 160);
  ft.MotCntl.EndPosition[3] := INI.ReadInteger(RobModell, 'ArmV', 150);
  if RobModell <> 'Rob5' then begin
    if RobTyp = rtGreifer then ft.MotCntl.EndPosition[4] :=
                          INI.ReadInteger(RobModell, 'Greifer', 28);
                          end
  else begin
    ft.MotCntl.EndPosition[4] := INI.ReadInteger('Rob5', 'Wagen',   1000);
    ft.MotCntl.EndPosition[5] := INI.ReadInteger('Rob5', 'Greifer', 28);
    end
end;


procedure TfrmMain.IniSchreiben;
// --- Schreiben der ftTeach.INI-Daten ----------------------
begin
  INI := TIniFile.Create(Pfad + 'ftTeach.INI');
  INI.WriteInteger('Common', 'Left', Self.Left);
  INI.WriteInteger('Common', 'Top', Self.Top);
  INI.WriteString('Common', 'RobModel', RobModell);
  INI.WriteString('Port', 'PortName', PortName);
  INI.WriteInteger('Port', 'LPTDelay', LPTDelay);
  INI.WriteString(RobModell, 'RobType', RobTyp);
  INI.WriteString(RobModell, 'RobText', RobBez);
  INI.WriteInteger(RobModell, 'Sule', ft.MotCntl.EndPosition[1]);
  INI.WriteInteger(RobModell, 'ArmH',  ft.MotCntl.EndPosition[2]);
  INI.WriteInteger(RobModell, 'ArmV',  ft.MotCntl.EndPosition[3]);
  if RobModell <> 'Rob5' then begin
    if RobTyp = rtGreifer then INI.WriteInteger(RobModell, 'Greifer',
                                        ft.MotCntl.EndPosition[4]);
                                        end
  else begin
    INI.WriteInteger('Rob5', 'Wagen',   ft.MotCntl.EndPosition[4]);
    INI.WriteInteger('Rob5', 'Greifer', ft.MotCntl.EndPosition[5]);
    end;
end;


procedure TfrmMain.ModellDaten;
// --- Listen der Modelldaten ---------------------------------------------
begin
  lblTitel.Caption := RobModell + ' : ' + robBez;
  memDaten.Clear;
  memDaten.Lines.Add('Modelldaten');
  memDaten.Lines.Add('Modell : ' + RobModell);
  memDaten.Lines.Add('Port : '   +  PortName);
  memDaten.Lines.Add(' ');
  memDaten.Lines.Add('Arbeitsraum');
  memDaten.Lines.Add('Sule : ' + IntToStr(ft.MotCntl.EndPosition[1]));
  memDaten.Lines.Add('ArmH : '  + IntToStr(ft.MotCntl.EndPosition[2]));
  memDaten.Lines.Add('ArmV : '  + IntToStr(ft.MotCntl.EndPosition[3]));
  if RobModell <> 'Rob5' then begin
    if RobTyp = rtGreifer then
      memDaten.Lines.Add('Greifer : ' + IntToStr(ft.MotCntl.EndPosition[4]));
      shpWagen.Visible := false;
      shpM5R.Visible   := false;
      shpM5L.Visible   := false;
      lblM5Pos.Visible := false;
      shpM6.Visible    := false;
      lblM6Zu.Visible  := false;
      lblM6Auf.Visible := false;
      shpM7.Visible    := false;
      lblM7Zu.Visible  := false;
      lblM7Auf.Visible := false;
      shpM8.Visible    := false;
      lblM8Zu.Visible  := false;
      lblM8Auf.Visible := false;
      end
  else begin
    memDaten.Lines.Add('Wagen : '   + IntToStr(ft.MotCntl.EndPosition[4]));
    memDaten.Lines.Add('Greifer : ' + IntToStr(ft.MotCntl.EndPosition[5]));
      shpWagen.Visible := true;
      shpM5R.Visible   := true;
      shpM5L.Visible   := true;
      lblM5Pos.Visible := true;
      shpM6.Visible    := true;
      lblM6Zu.Visible  := true;
      lblM6Auf.Visible := true;
      shpM7.Visible    := true;
      lblM7Zu.Visible  := true;
      lblM7Auf.Visible := true;
      shpM8.Visible    := true;
      lblM8Zu.Visible  := true;
      lblM8Auf.Visible := true;
    end
end;


procedure TfrmMain.MotorListe;
// --- Aufbau der Motorliste, feste Werte --------------------------------
begin
  ft.MotCntl.Name[1]   := 'Sule';
  ft.MotCntl.Nr[1]     := 1;
  ft.MotCntl.Impuls[1] := 2;
  ft.MotCntl.Ende[1]   := 1;

  ft.MotCntl.Name[2]   := 'Arm horizontal';
  ft.MotCntl.Nr[2]     := 2;
  ft.MotCntl.Impuls[2] := 4;
  ft.MotCntl.Ende[2]   := 3;

  ft.MotCntl.Name[3]   := 'Arm vertikal';
  ft.MotCntl.Nr[3]     := 3;
  ft.MotCntl.Impuls[3] := 6;
  ft.MotCntl.Ende[3]   := 5;

  if RobModell <> 'Rob5' then begin
    if RobTyp = rtGreifer then begin
      ft.MotCntl.Name[4]   := 'Greifer';
      ft.MotCntl.Nr[4]     := 4;
      ft.MotCntl.Impuls[4] := 8;
      ft.MotCntl.Ende[4]   := 7;
      end
    else ft.MotCntl.EndPosition[4] := 9999;
    end
  else begin
    ft.MotCntl.Name[4]   := 'Wagen';
    ft.MotCntl.Nr[4]     := 5;
    ft.MotCntl.Impuls[4] := 10;
    ft.MotCntl.Ende[4]   := 9;

    ft.MotCntl.Name[5]   := 'Greifer';
    ft.MotCntl.Nr[5]     := 4;
    ft.MotCntl.Impuls[5] := 8;
    ft.MotCntl.Ende[5]   := 7;

    ft.MotCntl.EndPosition[6] := 9999;
    ft.MotCntl.EndPosition[7] := 9999;
    ft.MotCntl.EndPosition[8] := 9999;
    end
end;


procedure TfrmMain.FormClose(Sender: TObject; var Action: TCloseAction);
// --- bedingtes Beenden des Programms -----------------------------------
begin
  if PrgModus = mdRun then begin Action := caNone; exit; end;
  Beenden;
end;


procedure TfrmMain.FormCreate(Sender: TObject);
begin
  Self.Caption := Application.Title;
  PrgModus := mdNone;
  ft := TFishRobot.Create;
  Pfad := ExtractFilePath(Application.ExeName);
  SetCurrentDir(ExtractFileDir(Application.ExeName));
  INI := TIniFile.Create(Pfad + 'ftTeach.INI');
  IniLesen;
  MotorListe;
  ModellDaten;
  mnuNeuClick(Self);
  ModusWechsel(mdEin);
end;


procedure TfrmMain.ModusWechsel(NewMode: TPrgModus);
// --- Schalten in den gewnschten Betriebsmodus --------------------
//     Setzen/Lschen Sperren, Beschriften, ProModus : ... ----------
begin
  case NewMode of
  mdEin: begin              // --- nach Programmstart, nicht wiederholbar ---
    lblPrgModus.Caption  := 'EINschalten';
    cmdAction.Caption    := 'EIN';
    cmdAction.Enabled    := true;
    cmdEnde.Caption      := 'Abbrechen';
    cmdEnde.Enabled      := true;
    cmdInterface.Enabled := false;
    pnlFahren.Color      := clBtnFace;
    pnlFahren.Enabled    := false;
    pnlPosition.Enabled  := false;
    pnlPosition.Color    := clBtnFace;
    pnlRun.Enabled       := false;
    pnlRun.Color         := clBtnFace;
    mnuDatei.Enabled     := true;
    mnuOptionen.Enabled  := true;
    mnuHilfe.Enabled     := true;
    PrgModus             := mdEin;
    end;
  mdHome: begin             // --- nach OpenInterface, nicht wiederholbar ---
    lblPrgModus.Caption  := 'Home anfahren';
    cmdAction.Caption    := 'STARTEN';
    cmdAction.Enabled    := true;
    cmdEnde.Caption      := 'ENDE';
    cmdEnde.Enabled      := true;
    cmdInterface.Enabled := true;
    pnlFahren.Color      := clBtnFace;
    pnlFahren.Enabled    := false;
    pnlPosition.Enabled  := false;
    pnlPosition.Color    := clBtnFace;
    pnlRun.Enabled       := true;
    pnlRun.Color         := clBtnFace;
    mnuDatei.Enabled     := true;
    mnuOptionen.Visible  := false;
    mnuHilfe.Enabled     := true;
    PrgModus             := mdHome;
    end;
  mdTeachIn: begin          // --- nach erfolgreichem Home : Normal-Status
                            //     stellt sich nach Fahren wieder ein
    lblPrgModus.Caption  := 'TeachIn';
    cmdAction.Caption    := 'HOME';
    cmdAction.Enabled    := true;
    cmdEnde.Caption      := 'ENDE';
    cmdEnde.Enabled      := true;
    cmdInterface.Enabled := true;
    pnlFahren.Color      := clHellGrau;
    pnlFahren.Enabled    := true;
    pnlPosition.Enabled  := true;
    pnlPosition.Color    := clHellGrau;
    pnlRun.Enabled       := true;
    pnlRun.Color         := clHellGrau;
    mnuDatei.Enabled     := true;
    mnuOptionen.Visible  := false;
    mnuHilfe.Enabled     := true;
    PrgModus             := mdTeachIn;
    end;
  mdRun: begin              // --- whrend einer Robot-Fahrt : ScriptStarten,
                            //     Fahren, Home
    lblPrgModus.Caption  := 'RUN';
    cmdAction.Caption    := 'HALT';
    cmdAction.Enabled    := true;
    cmdEnde.Caption      := 'ENDE';
    cmdEnde.Enabled      := false;
    cmdInterface.Enabled := false;
    pnlFahren.Color      := clBtnFace;
    pnlFahren.Enabled    := false;
    pnlPosition.Enabled  := false;
    pnlPosition.Color    := clBtnFace;
    pnlRun.Enabled       := false;
    pnlRun.Color         := clBtnFace;
    mnuDatei.Enabled     := false;
    mnuOptionen.Visible  := false;
    mnuHilfe.Enabled     := false;
    PrgModus             := mdRun;
    end;
  end;
end;


function TfrmMain.MotToScript: string;
// --- Aufbereiten der aktuellen MotCntl.Position zu einer Scriptzeile ---
var Zeile: string;
begin
  if RobModell <> 'Rob5' then begin
    Zeile  := Format('%6d', [ft.MotCntl.Position[1]]);
    Zeile  := Zeile + Format('%6d', [ft.MotCntl.Position[2]]);
    Zeile  := Zeile + Format('%6d', [ft.MotCntl.Position[3]]);
    Zeile  := Zeile + Format('%6d', [MoveWerte[4]]);
    end
  else begin
    Zeile  := Format('%4d', [ft.MotCntl.Position[1]]);
    Zeile  := Zeile + Format('%4d', [ft.MotCntl.Position[2]]);
    Zeile  := Zeile + Format('%4d', [ft.MotCntl.Position[3]]);
    Zeile  := Zeile + Format('%4d', [ft.MotCntl.Position[4]]);
    Zeile  := Zeile + Format('%4d', [MoveWerte[5]]);
    Zeile  := Zeile + Format('%2d', [MoveWerte[6]]);
    Zeile  := Zeile + Format('%2d', [MoveWerte[7]]);
    Zeile  := Zeile + Format('%2d', [MoveWerte[8]]);
    end;
  Result := Zeile;
end;


procedure TfrmMain.ScriptToMove;
// --- Aufbereiten einer Scriptzeile zu MoveWerten -----------------------
var Zeile: string;
begin
  if RobModell <> 'Rob5' then begin
    Zeile        := lstScript.Items[lstScript.ItemIndex];
    MoveWerte[1] := StrToInt(Copy(Zeile, 1,6));
    MoveWerte[2] := StrToInt(Copy(Zeile, 7,6));
    MoveWerte[3] := StrToInt(Copy(Zeile,13,6));
    MoveWerte[4] := StrToInt(Copy(Zeile,19,6));
    end
  else begin
    Zeile        := lstScript.Items[lstScript.ItemIndex];
    MoveWerte[1] := StrToInt(Copy(Zeile,  1,4));
    MoveWerte[2] := StrToInt(Copy(Zeile,  5,4));
    MoveWerte[3] := StrToInt(Copy(Zeile,  9,4));
    MoveWerte[4] := StrToInt(Copy(Zeile, 13,4));
    MoveWerte[5] := StrToInt(Copy(Zeile, 17,4));
    MoveWerte[6] := StrToInt(Copy(Zeile, 21,2));
    MoveWerte[7] := StrToInt(Copy(Zeile, 23,2));
    MoveWerte[8] := StrToInt(Copy(Zeile, 25,2));
    end
end;

procedure TfrmMain.Zusatz(OnOff: Cardinal);
// --- ffnen/Schlieen Zusatzgerat --------------------------------------
var Nr: Cardinal;
begin
  if RobModell <> 'Rob5' then Nr := 4 else Nr := 5;
  MoveWerte[Nr] := OnOff;
  if RobTyp = rtGreifer then begin
    ft.DriveGrip(Nr, OnOff)
    end
  else begin
    ft.SetMotor(ft.MotCntl.Nr[Nr], OnOff);
    ft.Pause(500);
    end;
end;

procedure TfrmMain.ZusatzM(ZusatzNr, OnOff: Cardinal);
// ---- Steuern Zusatzgerte M ------------------------------------------
begin
    MoveWerte[ZusatzNr] := OnOff;
  case ZusatzNr of
  6: begin
    ft.SetMotor(ZusatzNr, OnOff);
    end;
  7: begin
    ft.SetMotor(ZusatzNr, OnOff);
    end;
  8: begin
    if OnOff = 1 then ft.WaitForInput(11, true) else ft.WaitForInput(11, false);
    end;
  end;
end;

procedure TfrmMain.cmdEndeClick(Sender: TObject);
// --------------- Beenden des Programms --------------------------------
begin
  Self.Close;
end;


procedure TfrmMain.cmdActionClick(Sender: TObject);
// --- Haupt-Aktionen -----------------------------------------------------
begin
  if cmdAction.Caption = 'EIN' then begin    // --- Einschalten Interface
    ft.LPTDelay := lptDelay;
    if robModell = 'Rob5' then ft.Slave := true;
    if ft.OpenInterface(PortName) = ftiFehler then begin
      MessageDlg('Inpterfaceproblem mit : ' + PortName, mtError, [mbOK], 0);
      cmdAction.SetFocus; exit end;
    tmrI.Enabled := true;
    ModusWechsel(mdHome);
    end
  else                                      // --- NotHalt
   if cmdAction.Caption = 'HALT' then begin
    ft.NotHalt := true;
    chkWiederholen.Checked := false;
    ModusWechsel(mdTeachIn);
    end
  else begin                               // --- Anfahren HOME
    ModusWechsel(mdRun);
    HomeRun;
    ModusWechsel(mdTeachIn);
    end;
end;


procedure TfrmMain.cmdInterfaceClick(Sender: TObject);
// -------- InterfacePanel anzeigen ---------------------------------------
begin
  ft.ShowPanel(true, Left + Width - 360, Top + 60);
end;

procedure TfrmMain.cmdScriptStartenClick(Sender: TObject);
// --- Fahren nach Daten des aktuellen Scripts -----------------------------
begin
  ModusWechsel(mdRun);
  repeat
    lstScript.ItemIndex := -1;
    ft.NotHalt := false;
    repeat
      lstScript.ItemIndex := lstScript.ItemIndex + 1;
      ScriptToMove;
      if RobModell <> 'Rob5' then begin
        ft.MoveTo(MoveWerte[1], MoveWerte[2], MoveWerte[3]);
        Zusatz(MoveWerte[4]);
        end
      else begin
        ft.MoveTo(MoveWerte[1], MoveWerte[2], MoveWerte[3], MoveWerte[4]);
        Zusatz(MoveWerte[5]);
        ZusatzM(6, MoveWerte[6]);
        ZusatzM(7, MoveWerte[7]);
        ZusatzM(8, MoveWerte[8]);
        end;
    until (lstScript.ItemIndex = (lstScript.Items.Count - 1)) Or ft.NotHalt;
  until NOT chkWiederholen.Checked;
  ModusWechsel(mdTeachIn);
end;


procedure TfrmMain.cmdZuPositionClick(Sender: TObject);
// --- Auf die im Script markierte Position fahren ----------------------
begin
  case TButton(Sender).Tag of
  1: if lstScript.ItemIndex > 0 then
        lstScript.ItemIndex := lstScript.ItemIndex - 1;
  2: lstScript.ItemIndex := lstScript.ItemIndex + 1;
  3:;
  end;
  ModusWechsel(mdRun);
  ScriptToMove;
  ft.NotHalt := false;
  if RobModell <> 'Rob5' then begin
    ft.MoveTo(MoveWerte[1], MoveWerte[2], MoveWerte[3]);
    Zusatz(MoveWerte[4]);
    end
  else begin
    ft.MoveTo(MoveWerte[1], MoveWerte[2], MoveWerte[3], MoveWerte[4]);
    Zusatz(MoveWerte[5]);
    ZusatzM(6, MoveWerte[6]);
    ZusatzM(7, MoveWerte[7]);
    ZusatzM(8, MoveWerte[8]);
    end;
  ModusWechsel(mdTeachIn);
end;


procedure TfrmMain.cmdPosAnfugenClick(Sender: TObject);
// ------------ Anfgen einer neuen Position an das Script ----------------
begin
  lstScript.Items.Add(MotToScript);
  lstScript.ItemIndex := lstScript.Items.Count - 1;
  IsDirty := true;
end;

procedure TfrmMain.cmdPosSpeichernClick(Sender: TObject);
// ---- Speichern der aktuellen Position in die markierte Zeile ----------
begin
  if lstScript.Items.Count < 1 then exit;
  lstScript.Items[lstScript.ItemIndex] := MotToScript;
  IsDirty := true;
end;

procedure TfrmMain.cmdPosEinfugenClick(Sender: TObject);
// ---- Einfgen der aktuellen Position fr die markierte Zeile ----------
begin
  if lstScript.ItemIndex = -1 then exit;
  lstScript.Items.Insert(lstScript.ItemIndex,MotToScript);
  lstScript.ItemIndex := lstScript.ItemIndex - 1;
  IsDirty := true;
end;

procedure TfrmMain.cmdPosLoschenClick(Sender: TObject);
// --- Lschen der markierten Zeile -------------------------------------
var i: Cardinal;
begin
  if lstScript.Items.Count = 1 then exit;
  i := lstScript.ItemIndex;
  lstScript.Items.Delete(i);
  if i>0 then lstScript.ItemIndex := i - 1 else lstScript.ItemIndex := 0;
  IsDirty := true;
end;


procedure TfrmMain.shpMotMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
// --- TeachIn : freies Fahren ------------------------------------------
var Index: Cardinal;
begin
  Index := TShape(Sender).Tag;
  ft.NotHalt := false;

  case Index of
  1: ft.DriveFree(1,ftiLinks);
  2: ft.DriveFree(1,ftiRechts);
  3: ft.DriveFree(2,ftiLinks);
  4: ft.DriveFree(2,ftiRechts);
  5: ft.DriveFree(3,ftiLinks);
  6: ft.DriveFree(3,ftiRechts);
  7: ft.DriveFree(4,ftiLinks);
  8: ft.DriveFree(4,ftiRechts);
  end;

end;


procedure TfrmMain.shpMotMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
// --- TeachIn : Beenden freies Fahren --------------------------------
begin
  ft.NotHalt := true;
end;

procedure TfrmMain.lblM4Click(Sender: TObject);
// --- ffnen/Schlieen des Zusatzgertes ----------------------------------
begin
  ModusWechsel(mdRun);
  ft.NotHalt := false;
  Zusatz(TLabel(Sender).Tag);
  ModusWechsel(mdTeachIn);
end;

procedure TfrmMain.lblM6Click(Sender: TObject);
begin
  ModusWechsel(mdRun);
  ft.NotHalt := false;
  ZusatzM(6, TLabel(Sender).Tag);
  ModusWechsel(mdTeachIn);
end;

procedure TfrmMain.lblM7Click(Sender: TObject);
begin
  ModusWechsel(mdRun);
  ft.NotHalt := false;
  ZusatzM(7, TLabel(Sender).Tag);
  ModusWechsel(mdTeachIn);
end;

procedure TfrmMain.lblM8Click(Sender: TObject);
begin
  ModusWechsel(mdRun);
  ft.NotHalt := false;
  ZusatzM(8, TLabel(Sender).Tag);
  ModusWechsel(mdTeachIn);
end;


procedure TfrmMain.tmrITimer(Sender: TObject);
// --- berwachen des Interfaces ------------------------------------------
var EW: LongWord;
begin
  EW := ft.Outputs;
  if ft.GetInputs = ftiFehler then begin
    shpInterface.Brush.Color := clRed;
    exit;
    end
  else shpInterface.Brush.Color := clLime;
  lblM1Pos.Caption := IntToStr(ft.MotCntl.Position[1]);
  if (EW AND $3)    > 0 then shpSaule.Brush.Color := clLime
  else shpSaule.Brush.Color := clWhite;
  lblM2Pos.Caption := IntToStr(ft.MotCntl.Position[2]);
  if (EW AND $C)    > 0 then shpArmH.Brush.Color := clLime
  else shpArmH.Brush.Color := clWhite;
  lblM3Pos.Caption := IntToStr(ft.MotCntl.Position[3]);
  if (EW AND $30)   > 0 then shpArmV.Brush.Color := clLime
  else shpArmV.Brush.Color := clWhite;
  if robModell <> 'Rob5' then
    if (EW AND $C0) > 0 then shpZusatz.Brush.Color := clLime
    else shpZusatz.Brush.Color := clWhite
  else begin
    lblM5Pos.Caption := IntToStr(ft.MotCntl.Position[4]);
    if (EW AND $300)   > 0 then shpWagen.Brush.Color := clLime
    else shpWagen.Brush.Color :=clWhite;
    if (EW AND $C0)   > 0 then shpZusatz.Brush.Color := clLime
    else shpZusatz.Brush.Color := clWhite;
    if (EW AND $C00)  > 0 then shpM6.Brush.Color := clLime
    else shpM6.Brush.Color := clWhite;
    if (EW AND $3000) > 0 then shpM7.Brush.Color := clLime
    else shpM7.Brush.Color := clWhite;
    if (EW AND $C000) > 0 then shpM8.Brush.Color := clLime
    else shpM8.Brush.Color := clWhite;
    if ft.GetInput(11) then shpM8.Brush.Color := clLime
    else shpM8.Brush.Color := clWhite;
    end;
end;


procedure TfrmMain.mnuEndeClick(Sender: TObject);
// --- Gesamtprogramm beenden ---------------------------
begin
 Self.Close;
end;


procedure TfrmMain.mnuOffnenClick(Sender: TObject);
// --- Script einlesen -------------------------------
begin
  dlgOpen.Filter := 'Rob Script|*.' + RobExt;
  dlgOpen.DefaultExt := RobExt;
  dlgOpen.InitialDir := Pfad;
  if NOT dlgOpen.Execute then exit;
  DateiName := ExtractFilename(dlgOpen.Filename);
  lstScript.Items.LoadFromFile(dlgOpen.FileName);
  IsDirty := false;
  Self.Caption := Application.Title + ' [' + DateiName + ']';
  lstScript.ItemIndex := 0;
end;


procedure TfrmMain.mnuNeuClick(Sender: TObject);
// --- neues Script anlegen --------------------
var i: Cardinal;
begin
  lstScript.Clear;
  Self.Caption := Application.Title + ' [Neu]';
  DateiName := '';
  for i := 1 to 8 do MoveWerte[i] := 0;
  if RobModell <> 'Rob5' then lstScript.Items.Add('     0     0     0     0')
  else lstScript.Items.Add('   0   0   0   0   0 0 0 0');
  lstScript.ItemIndex := 0;
  IsDirty := false;
end;


procedure TfrmMain.mnuSpeichernUClick(Sender: TObject);
// --- Script unter whlbaren Namen speichern ---------
begin
  dlgSave.Filter := 'Rob Script|*.' + RobExt;
  dlgSave.DefaultExt := RobExt;
  dlgSave.InitialDir := Pfad;
  if NOT dlgSave.Execute then exit;
  lstScript.Items.SaveToFile(dlgSave.Filename);
  DateiName := ExtractFilename(dlgSave.Filename);
  Self.Caption := Application.Title + ' [' + Dateiname + ']';
  IsDirty := false;
end;


procedure TfrmMain.mnuSpeichernClick(Sender: TObject);
// ------------- Script speichern ----------------------
begin
  if DateiName = '' then mnuSpeichernUClick(Self)
  else lstScript.Items.SaveToFile(Pfad + DateiName);
  IsDirty := false;
end;

procedure TfrmMain.mnuModellClick(Sender: TObject);
// --------- Modellauswahl, Modellparameter ------------------------------
begin
  frmModell.Left := Self.Left + Self.Width  - frmModell.Width  - 20;
  frmModell.Top  := Self.Top  + Self.Height - frmModell.Height - 16;
  frmModell.ShowModal;
  Modelldaten;
end;

procedure TfrmMain.mnuAboutClick(Sender: TObject);
// --- Anzeige der AboutBox ----------------------------------------------
begin
  frmAbout.Left := Self.Left + Self.Width  - frmAbout.Width  - 32;
  frmAbout.Top  := Self.Top  + Self.Height - frmAbout.Height - 20;
  frmAbout.ShowModal;
end;

procedure TfrmMain.mnuSchnittClick(Sender: TObject);
// ---- Auswahl der Schnittstelle ---------------------------------------
begin
  frmSchnitt.Left := Self.Left + Self.Width  - frmSchnitt.Width  - 20;
  frmSchnitt.Top  := Self.Top  + Self.Height - frmSchnitt.Height - 16;
  frmSchnitt.ShowModal;
  ModellDaten;
end;

procedure TfrmMain.mnuInhaltClick(Sender: TObject);
// -------------------- Anzeige Help-Inhalt -----------------------------
begin
  Application.HelpCommand(HELP_FINDER, 0);
end;

end.




