// ----------------------------------------------------------------------------
//
// ftTeach.DPR                                           Ulrich Mller 08.09.02
//                                                       PCS1700        Delphi4
// ftTeach fr Industry Robots
//
// Professionelles TeachIn-Programm fr die Industry Robots
// Rob2 : Schweiroboter, Rob3 : Sulen- und Rob4 Knickarmroboter
// Rob5 : Sonderform des Sulenroboters mit Extension Module.
//        ber das Ext Module werden ein weiterer RobMotor (zB. zum Betrieb
//        eines Wagens auf dem der Rob steht, M5 mit E9 End- und E10
//        Impulstaster) und 3 Schaltausgnge M6-M7(M8) betrieben. Die Bedienung
//        erfolgt wie gewohnt ber das TeachIn-Panel.
//        Zustzlich E11 Abfrage mit WaitForInput
//
// Eingesetzt wird FishFa50.PAS mit umFish20.DLL.
//
// Interfacebelegung :
// Rob2-Rob4 ein Interface
// M1 Sule mit E1 Ende- und E2 Impulstaster
// M2 ArmH  mit E3 Ende- und E4 Impulstaster
// M3 ArmV  mit E5 Ende- und E6 Impulstaster
// M4 Greifer mit E7 Ende- und E8 Impulstaster bzw.
//    nur M4 beim Rob2
// Rob5 mit Extension Module
// M1 - M4 wie gehabt
// M5 Wagen mit E9 Ende- und E10 Impulstaster
// M6-M8 einfache Ein/Ausausgnge M8 ist totgesetzt dafr
// E11   Eingang der ber den M8 Button bettigt wird
//       es wird wahlweise (+ : On, - : Off) auf E11 gewartet
//
// ----------------------------------------------------------------------------

program ftTeach;

uses
  Forms,
  ftMain in 'ftMain.pas' {frmMain},
  ftModell in 'ftModell.pas' {frmModell},
  ftSchnit in 'ftSchnit.pas' {frmSchnitt},
  ftAbout in 'ftAbout.pas' {frmAbout},
  FishFa50 in 'FishFa50.pas' {frmPanel};

{$R *.RES}

begin
  Application.Initialize;
  Application.Title := 'ftTeach fr Industry Robots';
  Application.HelpFile := 'ftTeach.hlp';
  Application.CreateForm(TfrmMain, frmMain);
  Application.CreateForm(TfrmModell, frmModell);
  Application.CreateForm(TfrmSchnitt, frmSchnitt);
  Application.CreateForm(TfrmAbout, frmAbout);
  Application.Run;
end.
