// -----------------------------------------------------------------------------------
//
// umFish20VC.h                                                Ulrich Mller    4.3.00
//                                                             Procida 400NT  VC++ 6.0
//
// Basisfunktionen fr die fischertechnik Interfaces (seriell und parallell)
//     einschl. WinRT fr parallel Port
// 
// -----------------------------------------------------------------------------------


typedef struct {
  HANDLE hCom;                 // --- PortHandle / Openflag ( = 0)
  DWORD PortID;                //     IO-Adresse bei LPT
  DWORD LPTDelay;              //     LPT Verzgerungsfaktor
  DWORD LPTAnalog;             //     LPT Analogfaktor 
  DWORD ECount;                //     Anzahl E-Eingnge (8/16)
	DWORD FID;                   // --- MultiMediaTimer Handle
	DWORD PollInterval;          //     Pollinterval des MM-Timers
	DWORD AnalogScan;            //     Pollen auch der Analogeingnge (0/1)
	DWORD OutputStatus;          // --- Status der M-Ausgnge
	DWORD InputStatus;           //     Status der E-Eingnge
  DWORD Analogs[2];            //     Werte der A-Eingnge
	DWORD Counters[16];          //     Impulszhler an den E-Eingngen
} ftiDCB;

DWORD __stdcall umOpenInterface(ftiDCB *Interface, LPCSTR ComName);
DWORD __stdcall umCloseInterface(ftiDCB *Interface);
DWORD __stdcall umGetVersion();
BOOL  __stdcall umGetInput(ftiDCB *Interface, DWORD InputNr);
DWORD __stdcall umSetLamp(ftiDCB *Interface, DWORD LampNr, DWORD OnOff);
DWORD __stdcall umSetMotor(ftiDCB *Interface, DWORD MotorNr, DWORD Direction);
DWORD __stdcall StartDriver();
DWORD __stdcall StopDriver();

const DWORD ftiAus    = 0;
const DWORD ftiEin    = 1;
const DWORD ftiLinks  = 1;
const DWORD ftiRechts = 2;

const DWORD ftiFehler = 0x0001FFFF;
